diff -urN libgnomedb/libgnomedb/gnome-db-raw-grid.c libgnomedbnew/libgnomedb/gnome-db-raw-grid.c
--- libgnomedb/libgnomedb/gnome-db-raw-grid.c	2008-12-30 11:22:49.000000000 +0100
+++ libgnomedbnew/libgnomedb/gnome-db-raw-grid.c	2009-04-19 18:38:14.000000000 +0200
@@ -1042,9 +1452,9 @@
 		/* single direct parameter */
 		gint col;
 
-		g_assert (g_slist_length (group->nodes) == 1);
+		g_assert (g_slist_length (group->group->nodes) == 1);
 		col = g_slist_index (((GdaSet *)grid->priv->iter)->holders,
-				     GDA_SET_NODE (group->nodes->data)->holder);
+				     GDA_SET_NODE (group->group->nodes->data)->holder);
 		gnome_db_data_store_set_value (grid->priv->store, &iter, offset + col, attribute);
 	}
 	gda_value_free (attribute);
@@ -1650,11 +2060,11 @@
 		list = columns;
 		while (list) {
 			if (gtk_tree_view_column_get_visible (GTK_TREE_VIEW_COLUMN (list->data))) {
-				GdaSetGroup *group;
+				GnomeDbSetGroup *group;
 				GSList *params;
 
-				group = g_object_get_data (G_OBJECT (list->data), "group");
-				for (params = group->nodes; params; nb_cols ++, params = params->next) 
+				group = g_object_get_data (G_OBJECT (list->data), "__gnome_db_group");
+				for (params = group->group->nodes; params; nb_cols ++, params = params->next) 
 					cols [nb_cols] = g_slist_index (((GdaSet *)grid->priv->iter)->holders,
 									GDA_SET_NODE (params->data)->holder);
 			}
@@ -1887,18 +2297,15 @@
 }
 
 static ColumnData *
-get_column_data (GnomeDbRawGrid *grid, GdaSetGroup *group)
+get_column_data (GnomeDbRawGrid *grid, GnomeDbSetGroup *group)
 {
-	ColumnData *retval = NULL;
-	GSList *list = grid->priv->columns_data;
-	while (list && !retval) {
+	GSList *list;
+	for (list = grid->priv->columns_data; list; list = list->next) {
 		if (COLUMN_DATA (list->data)->group == group)
-			retval = COLUMN_DATA (list->data);
-
-		list = g_slist_next (list);
+			return COLUMN_DATA (list->data);
 	}
 
-	return retval;
+	return NULL;
 }
 
 /**
@@ -1953,7 +2360,7 @@
 	GnomeDbRawGrid *grid;
 	GdaHolder *param;
 	ColumnData *column_data;
-	GdaSetGroup *group;
+	GnomeDbSetGroup *group;
 
 	g_return_if_fail (iface && GNOME_DB_IS_RAW_GRID (iface));
 	grid = GNOME_DB_RAW_GRID (iface);
@@ -1965,7 +2372,7 @@
 		param = gda_data_model_iter_get_holder_for_field (grid->priv->iter, column);
 		g_return_if_fail (param);
 
-		group = gda_set_get_group (GDA_SET (grid->priv->iter), param);
+		group = _gnome_db_set_get_group (grid->priv->iter_info, param);
 		g_return_if_fail (group);
 
 		column_data = get_column_data (grid, group);
@@ -1989,14 +2396,14 @@
 
 	if (column >= 0) {
 		GdaHolder *param;
-		GdaSetGroup *group;
+		GnomeDbSetGroup *group;
 		ColumnData *cdata;
 
 		/* setting applies only to the @column column */
 		param = gda_data_model_iter_get_holder_for_field (grid->priv->iter, column);
 		g_return_if_fail (param);
 		
-		group = gda_set_get_group (GDA_SET (grid->priv->iter), param);
+		group = _gnome_db_set_get_group (grid->priv->iter_info, param);
 		g_return_if_fail (group);
 
 		cdata = get_column_data (grid, group);
@@ -2087,7 +2494,7 @@
 }
 
 static void
-paramlist_public_data_changed_cb (GdaSet *paramlist, GnomeDbRawGrid *grid)
+paramlist_public_data_changed_cb (GnomeDbSet *info, GnomeDbRawGrid *grid)
 {
 	GList *columns, *list;
 
@@ -2095,6 +2502,7 @@
 	if (grid->priv->columns_data) {
 		GSList *list = grid->priv->columns_data;
 		while (list) {
+                        g_free (((ColumnData *) (list->data))->tooltip_text);
 			g_free (list->data);
 			list = g_slist_next (list);
 		}
@@ -2136,7 +2544,7 @@
 		g_list_free (cols);
 
 		/* re-create columns */
-		paramlist_public_data_changed_cb (paramlist, grid);
+		paramlist_public_data_changed_cb (grid->priv->iter_info, grid);
 
 		/* hide columns which were hidden */
 		cols = gtk_tree_view_get_columns (GTK_TREE_VIEW (grid));
@@ -2283,6 +2691,7 @@
 	if (grid->priv->columns_data) {
 		GSList *list = grid->priv->columns_data;
 		while (list) {
+                        g_free (((ColumnData *) (list->data))->tooltip_text);
 			g_free (list->data);
 			list = g_slist_next (list);
 		}
@@ -2292,7 +2701,7 @@
 	
 	/* private data set */
 	if (grid->priv->iter) {
-		g_signal_handlers_disconnect_by_func (grid->priv->iter,
+		g_signal_handlers_disconnect_by_func (grid->priv->iter_info,
 						      G_CALLBACK (paramlist_public_data_changed_cb), grid);
 		g_signal_handlers_disconnect_by_func (grid->priv->iter,
 						      G_CALLBACK (paramlist_param_attr_changed_cb), grid);
@@ -2301,7 +2710,9 @@
 		g_signal_handlers_disconnect_by_func (grid->priv->iter,
 						      G_CALLBACK (iter_validate_set_cb), grid);
 		g_object_unref (grid->priv->iter);
+		g_object_unref (grid->priv->iter_info);
 		grid->priv->iter = NULL;
+		grid->priv->iter_info = NULL;
 	}
 	
 	/* proxy */
@@ -2354,3 +2765,16 @@
 
 	return grid->priv->write_mode;
 }
+
+static void
+gnome_db_raw_grid_set_data_layout (GnomeDbDataWidget  *iface, gpointer  data)
+{
+	GnomeDbRawGrid *raw_grid;
+	
+	g_return_if_fail (GNOME_DB_IS_RAW_GRID (iface));
+	raw_grid = GNOME_DB_RAW_GRID (iface);
+	g_return_if_fail (raw_grid->priv);
+
+	g_object_set (G_OBJECT (raw_grid), "data_layout", data, NULL);
+}
+
diff -urN libgnomedb/libgnomedb/gnome-db-set.c libgnomedbnew/libgnomedb/gnome-db-set.c
--- libgnomedb/libgnomedb/gnome-db-set.c	1970-01-01 01:00:00.000000000 +0100
+++ libgnomedbnew/libgnomedb/gnome-db-set.c	2009-04-19 18:38:14.000000000 +0200
@@ -0,0 +1,407 @@
+/* gnome-db-set.c
+ *
+ * Copyright (C) 2009 Vivien Malerba
+ *
+ * This Library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Library General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU Library General Public License for more details.
+ *
+ * You should have received a copy of the GNU Library General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+ * USA
+ */
+
+#include <string.h>
+#include <glib/gi18n-lib.h>
+#include <libgda/libgda.h>
+#include <libgnomedb/gnome-db-set.h>
+#include "marshal.h"
+
+static void gnome_db_set_class_init (GnomeDbSetClass * class);
+static void gnome_db_set_init (GnomeDbSet *wid);
+static void gnome_db_set_dispose (GObject *object);
+
+static void gnome_db_set_set_property (GObject *object,
+				       guint param_id,
+				       const GValue *value,
+				       GParamSpec *pspec);
+static void gnome_db_set_get_property (GObject *object,
+				       guint param_id,
+				       GValue *value,
+				       GParamSpec *pspec);
+
+static void wrapped_set_public_data_changed_cb (GdaSet *wset, GnomeDbSet *set);
+static void clean_public_data (GnomeDbSet *set);
+static void compute_public_data (GnomeDbSet *set);
+static void compute_shown_columns_index (GnomeDbSetSource *dsource);
+static void compute_ref_columns_index (GnomeDbSetSource *dsource);
+
+
+struct _GnomeDbSetPriv
+{
+	GdaSet *set;
+};
+
+/* get a pointer to the parents to be able to call their destructor */
+static GObjectClass *parent_class = NULL;
+
+/* properties */
+enum
+{
+        PROP_0,
+	PROP_SET
+};
+
+/* signals */
+enum
+{
+        PUBLIC_DATA_CHANGED,
+        LAST_SIGNAL
+};
+
+static gint gnome_db_set_signals[LAST_SIGNAL] = { 0 };
+
+GType
+gnome_db_set_get_type (void)
+{
+	static GType type = 0;
+
+	if (G_UNLIKELY (type == 0)) {
+		static const GTypeInfo info = {
+			sizeof (GnomeDbSetClass),
+			(GBaseInitFunc) NULL,
+			(GBaseFinalizeFunc) NULL,
+			(GClassInitFunc) gnome_db_set_class_init,
+			NULL,
+			NULL,
+			sizeof (GnomeDbSet),
+			0,
+			(GInstanceInitFunc) gnome_db_set_init
+		};		
+
+		type = g_type_register_static (G_TYPE_OBJECT, "GnomeDbSet", &info, 0);
+	}
+
+	return type;
+}
+
+static void
+gnome_db_set_class_init (GnomeDbSetClass *class)
+{
+	GObjectClass   *object_class = G_OBJECT_CLASS (class);
+	
+	parent_class = g_type_class_peek_parent (class);
+	object_class->dispose = gnome_db_set_dispose;
+
+	/**
+         * GnomeDbSet::public-data-changed
+         * @set: the #GnomeDbSet
+         * 
+         * Gets emitted when @set's public data (#GnomeDbSetGroup or #GnomeDbSetSource values) have changed
+         */
+        gnome_db_set_signals[PUBLIC_DATA_CHANGED] =
+                g_signal_new ("public-data-changed",
+                              G_TYPE_FROM_CLASS (object_class),
+                              G_SIGNAL_RUN_FIRST,
+                              G_STRUCT_OFFSET (GnomeDbSetClass, public_data_changed),
+                              NULL, NULL,
+                              gnome_db_marshal_VOID__VOID, G_TYPE_NONE, 0);
+
+        class->public_data_changed = NULL;
+
+	/* Properties */
+        object_class->set_property = gnome_db_set_set_property;
+        object_class->get_property = gnome_db_set_get_property;
+	g_object_class_install_property (object_class, PROP_SET,
+                                         g_param_spec_object ("set", NULL, NULL, 
+							      GDA_TYPE_SET,
+							      G_PARAM_READABLE | G_PARAM_WRITABLE |
+							      G_PARAM_CONSTRUCT_ONLY));
+}
+
+static void
+gnome_db_set_init (GnomeDbSet *set)
+{
+	set->priv = g_new0 (GnomeDbSetPriv, 1);
+	set->priv->set = NULL;
+}
+
+/**
+ * gnome_db_set_new
+ * @set: a #GdaSet
+ *
+ * Creates a new #GnomeDbSet which wraps @set's properties
+ *
+ *  Returns: the new widget
+ */
+GnomeDbSet *
+gnome_db_set_new (GdaSet *set)
+{
+	g_return_val_if_fail (GDA_IS_SET (set), NULL);
+
+	return (GnomeDbSet *) g_object_new (GNOME_DB_TYPE_SET, "set", set, NULL);
+}
+
+static void
+gnome_db_set_dispose (GObject *object)
+{
+        GnomeDbSet *set;
+
+        g_return_if_fail (GNOME_DB_IS_SET (object));
+
+        set = GNOME_DB_SET (object);
+
+        if (set->priv) {
+                if (set->priv->set) {
+                        g_signal_handlers_disconnect_by_func (G_OBJECT (set->priv->set),
+                                                              G_CALLBACK (wrapped_set_public_data_changed_cb), set);
+                        g_object_unref (set->priv->set);
+                        set->priv->set = NULL;
+                }
+
+		clean_public_data (set);
+
+                g_free (set->priv);
+                set->priv = NULL;
+        }
+
+        /* for the parent class */
+        parent_class->dispose (object);
+}
+
+static void
+gnome_db_set_set_property (GObject *object,
+			   guint param_id,
+			   const GValue *value,
+			   GParamSpec *pspec)
+{
+	GnomeDbSet *set;
+	
+	set = GNOME_DB_SET (object);
+	
+	switch (param_id) {
+	case PROP_SET:
+		set->priv->set = g_value_get_object (value);
+		if (set->priv->set) {
+			g_object_ref (set->priv->set);
+			compute_public_data (set);
+			g_signal_connect (set->priv->set, "public-data-changed",
+					  G_CALLBACK (wrapped_set_public_data_changed_cb), set);
+		}
+		break;
+	default:
+		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, param_id, pspec);
+		break;
+	}
+}
+
+static void
+wrapped_set_public_data_changed_cb (GdaSet *wset, GnomeDbSet *set)
+{
+	clean_public_data (set);
+	compute_public_data (set);
+	g_signal_emit (set, gnome_db_set_signals[PUBLIC_DATA_CHANGED], 0);
+}
+
+static void
+clean_public_data (GnomeDbSet *set)
+{
+	TO_IMPLEMENT;
+	GSList *list;
+	
+	for (list = set->sources_list; list; list = list->next) {
+		GnomeDbSetSource *dsource = (GnomeDbSetSource*) list->data;
+		g_free (dsource->shown_cols_index);
+		g_free (dsource->ref_cols_index);
+		g_free (dsource);
+	}
+	g_slist_free (set->sources_list);
+	set->sources_list = NULL;
+
+	for (list = set->groups_list; list; list = list->next) {
+		GnomeDbSetGroup *dgroup = (GnomeDbSetGroup*) list->data;
+		g_free (dgroup);
+	}
+	g_slist_free (set->groups_list);
+	set->groups_list = NULL;
+}
+
+static void
+compute_public_data (GnomeDbSet *set)
+{
+	GSList *list;
+	GdaSet *aset = GDA_SET (set->priv->set);
+	GHashTable *hash;
+	
+	/* scan GdaSetSource list */
+	hash = g_hash_table_new (NULL, NULL);
+	for (list = aset->sources_list; list; list = list->next) {
+		GnomeDbSetSource *dsource;
+		dsource = g_new0 (GnomeDbSetSource, 1);
+		set->sources_list = g_slist_prepend (set->sources_list, dsource);
+		g_hash_table_insert (hash, list->data, dsource);
+
+		dsource->source = GDA_SET_SOURCE (list->data);
+		compute_shown_columns_index (dsource);
+		compute_ref_columns_index (dsource);
+	}
+	set->sources_list = g_slist_reverse (set->sources_list);
+
+	/* scan GdaSetGroup list */
+	for (list = aset->groups_list; list; list = list->next) {
+		GnomeDbSetGroup *dgroup;
+		dgroup = g_new0 (GnomeDbSetGroup, 1);
+		set->groups_list = g_slist_prepend (set->groups_list, dgroup);
+		dgroup->group = GDA_SET_GROUP (list->data);
+		dgroup->source = g_hash_table_lookup (hash, GDA_SET_GROUP (list->data)->nodes_source);
+	}
+	set->groups_list = g_slist_reverse (set->groups_list);
+
+	g_hash_table_destroy (hash);
+}
+
+static void
+compute_shown_columns_index (GnomeDbSetSource *dsource)
+{
+       gint ncols, nholders;
+       gint *mask = NULL, masksize = 0;
+
+       nholders = g_slist_length (dsource->source->nodes);
+       g_return_if_fail (nholders > 0);
+       ncols = gda_data_model_get_n_columns (GDA_DATA_MODEL (dsource->source->data_model));
+       g_return_if_fail (ncols > 0);
+
+       if (ncols > nholders) {
+               /* we only want columns which are not holders */
+               gint i, current = 0;
+
+               masksize = ncols - nholders;
+               mask = g_new0 (gint, masksize);
+               for (i = 0; i < ncols ; i++) {
+                       GSList *list = dsource->source->nodes;
+                       gboolean found = FALSE;
+                       while (list && !found) {
+                               if (GDA_SET_NODE (list->data)->source_column == i)
+                                       found = TRUE;
+                               else
+                                       list = g_slist_next (list);
+                       }
+                       if (!found) {
+                               mask[current] = i;
+                               current ++;
+                       }
+               }
+               masksize = current;
+       }
+       else {
+               /* we want all the columns */
+               gint i;
+
+               masksize = ncols;
+               mask = g_new0 (gint, masksize);
+               for (i=0; i<ncols; i++) {
+                       mask[i] = i;
+               }
+       }
+
+       dsource->shown_n_cols = masksize;
+       dsource->shown_cols_index = mask;
+}
+
+void
+compute_ref_columns_index (GnomeDbSetSource *dsource)
+{
+       gint ncols, nholders;
+       gint *mask = NULL, masksize = 0;
+
+       nholders = g_slist_length (dsource->source->nodes);
+       g_return_if_fail (nholders > 0);
+       ncols = gda_data_model_get_n_columns (GDA_DATA_MODEL (dsource->source->data_model));
+       g_return_if_fail (ncols > 0);
+
+       if (ncols > nholders) {
+               /* we only want columns which are holders */
+               gint i, current = 0;
+
+               masksize = ncols - nholders;
+               mask = g_new0 (gint, masksize);
+               for (i=0; i<ncols ; i++) {
+                       GSList *list = dsource->source->nodes;
+                       gboolean found = FALSE;
+                       while (list && !found) {
+                               if (GDA_SET_NODE (list->data)->source_column == i)
+                                       found = TRUE;
+                               else
+                                       list = g_slist_next (list);
+                       }
+                       if (found) {
+                               mask[current] = i;
+                               current ++;
+                       }
+               }
+               masksize = current;
+       }
+       else {
+               /* we want all the columns */
+               gint i;
+
+               masksize = ncols;
+               mask = g_new0 (gint, masksize);
+               for (i=0; i<ncols; i++) {
+                       mask[i] = i;
+               }
+       }
+
+       dsource->ref_n_cols = masksize;
+       dsource->ref_cols_index = mask;
+}
+
+
+static void
+gnome_db_set_get_property (GObject *object,
+				 guint param_id,
+				 GValue *value,
+				 GParamSpec *pspec)
+{
+	GnomeDbSet *set;
+
+	set = GNOME_DB_SET (object);
+	
+	switch (param_id) {
+	case PROP_SET:
+		g_value_set_object (value, set->priv->set);
+		break;
+	default:
+		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, param_id, pspec);
+		break;
+	}	
+}
+
+/**
+ * _gnome_db_set_get_group
+ */
+GnomeDbSetGroup  *
+_gnome_db_set_get_group (GnomeDbSet *dbset, GdaHolder *holder)
+{
+	GdaSetGroup *agroup;
+	GSList *list;
+	g_return_val_if_fail (GNOME_DB_IS_SET (dbset), NULL);
+	g_return_val_if_fail (GDA_IS_HOLDER (holder), NULL);
+
+	agroup = gda_set_get_group (dbset->priv->set, holder);
+	if (!agroup)
+		return NULL;
+	
+	for (list = dbset->groups_list; list; list = list->next) {
+		if (GNOME_DB_SET_GROUP (list->data)->group == agroup)
+			return GNOME_DB_SET_GROUP (list->data);
+	}
+	return NULL;
+}
diff -urN libgnomedb/libgnomedb/gnome-db-set.h libgnomedbnew/libgnomedb/gnome-db-set.h
--- libgnomedb/libgnomedb/gnome-db-set.h	1970-01-01 01:00:00.000000000 +0100
+++ libgnomedbnew/libgnomedb/gnome-db-set.h	2009-04-19 18:38:14.000000000 +0200
@@ -0,0 +1,104 @@
+/* gnome-db-set.h
+ *
+ * Copyright (C) 2009 Vivien Malerba
+ *
+ * This Library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Library General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU Library General Public License for more details.
+ *
+ * You should have received a copy of the GNU Library General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+ * USA
+ */
+
+#ifndef __GNOME_DB_SET__
+#define __GNOME_DB_SET__
+
+#include <gtk/gtk.h>
+#include <libgda/gda-decl.h>
+
+G_BEGIN_DECLS
+
+#define GNOME_DB_TYPE_SET          (gnome_db_set_get_type())
+#define GNOME_DB_SET(obj)          G_TYPE_CHECK_INSTANCE_CAST (obj, gnome_db_set_get_type(), GnomeDbSet)
+#define GNOME_DB_SET_CLASS(klass)  G_TYPE_CHECK_CLASS_CAST (klass, gnome_db_set_get_type (), GnomeDbSetClass)
+#define GNOME_DB_IS_SET(obj)       G_TYPE_CHECK_INSTANCE_TYPE (obj, gnome_db_set_get_type ())
+
+
+typedef struct _GnomeDbSet      GnomeDbSet;
+typedef struct _GnomeDbSetClass GnomeDbSetClass;
+typedef struct _GnomeDbSetPriv  GnomeDbSetPriv;
+
+typedef struct _GnomeDbSetGroup GnomeDbSetGroup;
+typedef struct _GnomeDbSetSource GnomeDbSetSource;
+
+struct _GnomeDbSetGroup {
+        GdaSetGroup      *group;
+        GnomeDbSetSource *source; /* if NULL, then @group->nodes contains exactly one entry */
+
+        /* Padding for future expansion */
+        gpointer      _gda_reserved1;
+        gpointer      _gda_reserved2;
+};
+
+#define GNOME_DB_SET_GROUP(x) ((GnomeDbSetGroup*)(x))
+
+struct _GnomeDbSetSource {
+        GdaSetSource   *source;
+
+	/* displayed columns in 'source->data_model' */
+ 	gint shown_n_cols;
+ 	gint *shown_cols_index;
+
+ 	/* columns used as a reference (corresponding to PK values) in 'source->data_model' */
+ 	gint ref_n_cols;
+ 	gint *ref_cols_index; 
+
+        /* Padding for future expansion */
+        gpointer        _gda_reserved1;
+        gpointer        _gda_reserved2;
+        gpointer        _gda_reserved3;
+        gpointer        _gda_reserved4;
+};
+
+#define GNOME_DB_SET_SOURCE(x) ((GnomeDbSetSource*)(x))
+
+/* struct for the object's data */
+struct _GnomeDbSet
+{
+	GObject         object;
+	GnomeDbSetPriv *priv;
+
+	/*< public >*/
+	GSList         *sources_list; /* list of GnomeDbSetSource */
+        GSList         *groups_list;  /* list of GnomeDbSetGroup */
+};
+
+/* struct for the object's class */
+struct _GnomeDbSetClass
+{
+	GObjectClass       parent_class;
+	void             (*public_data_changed)   (GnomeDbSet *set);
+};
+
+/* 
+ * Generic widget's methods 
+ */
+GType             gnome_db_set_get_type            (void) G_GNUC_CONST;
+
+GnomeDbSet       *gnome_db_set_new                 (GdaSet *set);
+GnomeDbSetGroup  *_gnome_db_set_get_group           (GnomeDbSet *dbset, GdaHolder *holder);
+
+G_END_DECLS
+
+#endif
+
+
+
diff -urN libgnomedb/libgnomedb/Makefile.am libgnomedbnew/libgnomedb/Makefile.am
--- libgnomedb/libgnomedb/Makefile.am	2008-12-30 11:22:49.000000000 +0100
+++ libgnomedbnew/libgnomedb/Makefile.am	2009-04-19 18:38:14.000000000 +0200
@@ -51,6 +51,7 @@
 	gnome-db-raw-form.h \
 	gnome-db-raw-grid.h \
 	gnome-db-server-operation.h \
+	gnome-db-set.h \
 	gnome-db-stock.h \
 	gnome-db-tools.h \
 	gnome-db-transaction-status.h \
@@ -92,6 +93,7 @@
 	gnome-db-raw-form.c \
 	gnome-db-raw-grid.c \
 	gnome-db-server-operation.c \
+	gnome-db-set.c \
 	gnome-db-stock.c \
 	gnome-db-tools.c \
 	gnome-db-transaction-status.c \
@@ -163,5 +165,9 @@
 marshal.c: marshal.list $(GLIB_GENMARSHAL)
 	$(GLIB_GENMARSHAL) $< --body --prefix=gnome_db_marshal > $@
 
-EXTRA_DIST =  marshal.list
+DTD_FILES = data_layout.dtd
+dtddir=$(LIBGNOMEDB_DTDDIR)
+dtd_DATA=$(DTD_FILES)
+
+EXTRA_DIST = $(DTD_FILES) marshal.list
 

diff -urN libgnomedb/libgnomedb/utility.c libgnomedbnew/libgnomedb/utility.c
--- libgnomedb/libgnomedb/utility.c	2008-12-30 11:22:49.000000000 +0100
+++ libgnomedbnew/libgnomedb/utility.c	2009-04-19 18:38:14.000000000 +0200
@@ -25,6 +25,8 @@
 #include <glib/gi18n-lib.h>
 #include "gnome-db-data-entry.h"
 #include "gnome-db-decl.h"
+#include "libgnomedb.h"
+#include <libgnomedb/binreloc/gnome-db-binreloc.h>
 
 /**
  * gnome_db_utility_entry_build_actions_menu
@@ -215,9 +217,9 @@
  * Returns: the attributes
  */
 guint
-gnome_db_utility_proxy_compute_attributes_for_group (GdaSetGroup *group, GnomeDbDataStore *store, 
-					    GdaDataModelIter *model_iter, GtkTreeIter *tree_iter, 
-					    gboolean *to_be_deleted)
+gnome_db_utility_proxy_compute_attributes_for_group (GnomeDbSetGroup *group, GnomeDbDataStore *store, 
+						     GdaDataModelIter *model_iter, GtkTreeIter *tree_iter, 
+						     gboolean *to_be_deleted)
 {
 	guint attributes = GDA_VALUE_ATTR_IS_NULL | GDA_VALUE_ATTR_CAN_BE_NULL |
                 GDA_VALUE_ATTR_IS_DEFAULT | GDA_VALUE_ATTR_CAN_BE_DEFAULT |
@@ -232,14 +234,14 @@
 	proxy = gnome_db_data_store_get_proxy (store);
         offset = gda_data_proxy_get_proxied_model_n_cols (proxy);
 
-        /* list the values in proxy_model for each param in GDA_SET_NODE (group->nodes->data)->params */
+        /* list the values in proxy_model for each param in GDA_SET_NODE (group->group->nodes->data)->params */
 	attributes = 0;
-        for (list = group->nodes; list; list = list->next) {
+        for (list = group->group->nodes; list; list = list->next) {
 		col = g_slist_index (((GdaSet*)model_iter)->holders, GDA_SET_NODE (list->data)->holder);
                 gtk_tree_model_get (GTK_TREE_MODEL (store), tree_iter,
                                     DATA_STORE_COL_TO_DELETE, &local_to_del,
                                     offset + col, &localattr, -1);
-		if (list == group->nodes)
+		if (list == group->group->nodes)
 			attributes = localattr;
 		else
 			attributes &= localattr;
@@ -267,7 +269,7 @@
  * freed.
  */
 GList *
-gnome_db_utility_proxy_compute_values_for_group (GdaSetGroup *group, GnomeDbDataStore *store, 
+gnome_db_utility_proxy_compute_values_for_group (GnomeDbSetGroup *group, GnomeDbDataStore *store, 
 						 GdaDataModelIter *model_iter, 
 						 GtkTreeIter *tree_iter, gboolean model_values)
 {
@@ -281,7 +283,7 @@
 		GSList *list;
 		GValue *value;
 
-		for (list = group->nodes; list; list = list->next) {
+		for (list = group->group->nodes; list; list = list->next) {
 			gint col;
 
 			col = g_slist_index (((GdaSet*)model_iter)->holders, GDA_SET_NODE (list->data)->holder);
@@ -291,13 +293,13 @@
 	}
 	else {
 		gint col, i, proxy_row;
-		GdaSetSource *source;
+		GnomeDbSetSource *source;
 		const GValue *value;
 		gboolean slow_way = FALSE;
 		gboolean ret_null = FALSE;
 
 		proxy_row = gnome_db_data_store_get_row_from_iter (store, tree_iter);
-		source = group->nodes_source;
+		source = group->source;
 		for (i = 0 ; (i < source->shown_n_cols)  && !ret_null; i++) {
 			col = source->shown_cols_index[i];
 #ifdef PROXY_STORE_EXTRA_VALUES
@@ -323,8 +325,8 @@
 				GSList *list;
 				gint j;
 				
-				cols_index = g_new0 (gint, g_slist_length (group->nodes));
-				for (list = group->nodes, j = 0; list; list = list->next, j++) {
+				cols_index = g_new0 (gint, g_slist_length (group->group->nodes));
+				for (list = group->group->nodes, j = 0; list; list = list->next, j++) {
 					gint colno;
 					colno = g_slist_index (((GdaSet*)model_iter)->holders, 
 							       GDA_SET_NODE (list->data)->holder);
@@ -334,10 +336,10 @@
 					key_values = g_slist_append (key_values, (GValue *) value);
 				}
 				
-				row = gda_data_model_get_row_from_values (GDA_DATA_MODEL (source->data_model), 
+				row = gda_data_model_get_row_from_values (GDA_DATA_MODEL (source->source->data_model), 
 									  key_values, cols_index);
 				if (row >= 0) {
-					value = gda_data_model_get_value_at (GDA_DATA_MODEL (source->data_model),
+					value = gda_data_model_get_value_at (GDA_DATA_MODEL (source->source->data_model),
 									     col, row, NULL);
 					retval = g_list_append (retval, (GValue *) value);
 				}
@@ -501,3 +503,89 @@
 	gtk_dialog_run (GTK_DIALOG (dlg));
 	gtk_widget_destroy (dlg);
 }
+
+/**
+ * gnome_db_utility_set_data_layout_from_file
+ * @data_widget:
+ * @file_name: XML data layout file
+ *
+ * Set a data layout to @data_widget according specifications in @file_name
+ */
+void
+gnome_db_utility_set_data_layout_from_file (GnomeDbDataWidget  *data_widget, const gchar  *file_name, const gchar  *parent_table)
+{
+	g_return_if_fail (file_name != NULL);
+	g_return_if_fail (parent_table != NULL);
+
+	xmlDocPtr doc;
+	doc = xmlParseFile (file_name);
+	if (doc == NULL) {
+		g_warning (_("'%s' Document not parsed successfully\n"), file_name);
+		return;
+	}
+
+	xmlDtdPtr dtd = NULL;
+
+	gchar *file = gnome_db_gbr_get_file_path (GNOME_DB_DATA_DIR,
+						  LIBGNOMEDB_ABI_NAME,
+						  "dtd",
+						  "data_layout.dtd",
+						  NULL);
+	if (g_file_test (file, G_FILE_TEST_EXISTS))
+		dtd = xmlParseDTD (NULL, file);
+	if (dtd == NULL) {
+		g_warning (_("'%s' DTD not parsed successfully. "
+			     "XML data layout validation will not be "
+			     "performed (some errors may occur)"), file);
+	}
+	g_free (file);
+
+	/* Get the root element node */
+	xmlNodePtr root_node = NULL;
+	root_node = xmlDocGetRootElement (doc);
+
+	/* Must have root element, a name and the name must be "data_layouts" */
+	if (!root_node ||
+	    !root_node->name ||
+	    xmlStrcmp (root_node->name, "data_layouts")) {
+		xmlFreeDoc (doc);
+		return;
+	}
+
+	xmlNodePtr node;
+	for (node = root_node->children; node != NULL; node = node->next) {
+
+		if (node->type == XML_ELEMENT_NODE &&
+		    !xmlStrcmp (node->name, (const xmlChar *) "data_layout")) {
+			gboolean retval = FALSE;
+			xmlChar *str;
+
+			str = xmlGetProp (node, "parent_table");
+			if (str) {
+				if (strcmp (str, parent_table) == 0)
+					retval = TRUE;
+				//g_print ("parent_table: %s\n", str);
+				xmlFree (str);
+			}
+
+			str = xmlGetProp (node, "name");
+			if (str) {
+				if (retval == TRUE &&
+				    ((GNOME_DB_IS_RAW_GRID(data_widget) &&
+				      strcmp (str, "list") == 0) ||
+				     (GNOME_DB_IS_RAW_FORM(data_widget) &&
+				      strcmp (str, "details") == 0)))  // Now proceed
+					gnome_db_data_widget_set_data_layout (data_widget, node);
+				//g_print ("name: %s\n", str);
+				xmlFree (str);
+			}
+		}
+	}
+
+	/* Free the document */
+	xmlFreeDoc (doc);
+
+	/* Free the global variables that may
+	 * have been allocated by the parser */
+	xmlCleanupParser ();
+}
diff -urN libgnomedb/libgnomedb/utility.h libgnomedbnew/libgnomedb/utility.h
--- libgnomedb/libgnomedb/utility.h	2008-12-30 11:22:49.000000000 +0100
+++ libgnomedbnew/libgnomedb/utility.h	2009-04-19 18:38:14.000000000 +0200
@@ -22,6 +22,7 @@
 #include <libgda/gda-set.h>
 #include "gnome-db-data-entry.h"
 #include "gnome-db-data-store.h"
+#include "gnome-db-set.h"
 
 /*
  *
@@ -37,16 +38,17 @@
  * corresponding to the columns for the parameters in @group (as described by @model_iter), 
  * at row pointed by @tree_iter
  */
-guint            gnome_db_utility_proxy_compute_attributes_for_group (GdaSetGroup *group, 
-							     GnomeDbDataStore *store, GdaDataModelIter *model_iter, 
-							     GtkTreeIter *tree_iter, 
-							     gboolean *to_be_deleted);
-GList           *gnome_db_utility_proxy_compute_values_for_group     (GdaSetGroup *group, 
-							     GnomeDbDataStore *store, GdaDataModelIter *model_iter, 
-							     GtkTreeIter *tree_iter, gboolean model_values);
+guint            gnome_db_utility_proxy_compute_attributes_for_group (GnomeDbSetGroup *group, 
+								      GnomeDbDataStore *store, GdaDataModelIter *model_iter, 
+								      GtkTreeIter *tree_iter, 
+								      gboolean *to_be_deleted);
+GList           *gnome_db_utility_proxy_compute_values_for_group     (GnomeDbSetGroup *group, 
+								      GnomeDbDataStore *store, GdaDataModelIter *model_iter, 
+								      GtkTreeIter *tree_iter, gboolean model_values);
 
 /*
  * Some dialogs used by GnomeDbDataWidget widgets
  */
 gboolean   gnome_db_utility_display_error_with_keep_or_discard_choice (GnomeDbDataWidget *form, GError *filled_error);
 void       gnome_db_utility_display_error                             (GnomeDbDataWidget *form, gboolean can_discard, GError *filled_error);
+void       gnome_db_utility_set_data_layout_from_file (GnomeDbDataWidget  *data_widget, const gchar  *file_name,  const gchar  *parent_table);
